























































































































 


































































































































































 























































































































































































 





















































 










 








































































































































































































































 










                                
                                

                                
                                

                                
                                

                                





































module util_Table
  implicit none

  interface

     

     subroutine Util_TableCreate (handle, flags)
       implicit none
       integer               handle
       integer               flags
     end subroutine Util_TableCreate

     subroutine Util_TableClone (ierr, handle)
       implicit none
       integer               ierr
       integer               handle
     end subroutine Util_TableClone

     subroutine Util_TableDestroy (ierr, handle)
       implicit none
       integer               ierr
       integer               handle
     end subroutine Util_TableDestroy

     

     subroutine Util_TableQueryFlags (flags, handle)
       implicit none
       integer               flags
       integer               handle
     end subroutine Util_TableQueryFlags

     subroutine Util_TableQueryNKeys (nkeys, handle)
       implicit none
       integer               nkeys
       integer               handle
     end subroutine Util_TableQueryNKeys

     subroutine Util_TableQueryMaxKeyLength (maxkeylength, handle)
       implicit none
       integer               maxkeylength
       integer               handle
     end subroutine Util_TableQueryMaxKeyLength

     subroutine Util_TableQueryValueInfo &
          (keyinfo, handle, type_code, N_elements, key)
       implicit none
       integer               keyinfo
       integer               handle
       INTEGER*4              type_code
       INTEGER*4              N_elements
       character(*)          key
     end subroutine Util_TableQueryValueInfo

     

     subroutine Util_TableDeleteKey (ierr, handle, key)
       implicit none
       integer               ierr
       integer               handle
       character(*)          key
     end subroutine Util_TableDeleteKey

     

     subroutine Util_TableCreateFromString (handle, string)
       implicit none
       integer               handle
       character(*)          string
     end subroutine Util_TableCreateFromString

     
     subroutine Util_TableSetString (info, handle, string, key)
       implicit none
       integer               info
       integer               handle
       character(*)          string
       character(*)          key
     end subroutine Util_TableSetString

     subroutine Util_TableGetString (length, handle, buffer, key)
       implicit none
       integer               length
       integer               handle
       character(*)          buffer
       character(*)          key
     end subroutine Util_TableGetString

     

     subroutine Util_TableSetGeneric (info, handle, type_code, value_ptr, key)
       implicit none
       integer               info
       integer               handle
       integer               type_code
       integer*8 value_ptr
       character(*)          key
     end subroutine Util_TableSetGeneric

     subroutine Util_TableSetGenericArray &
          (info, handle, type_code, N_elements, array, key)
       implicit none
       integer               info
       integer               handle
       integer               type_code
       integer               N_elements
       integer*8 array(*)
       character(*)          key
     end subroutine Util_TableSetGenericArray

     subroutine Util_TableGetGeneric &
          (length, handle, type_code, value_ptr, key)
       implicit none
       integer               length
       integer               handle
       integer               type_code
       integer*8          value_ptr
       character(*)          key
     end subroutine Util_TableGetGeneric

     subroutine Util_TableGetGenericArray &
          (length, handle, type_code, N_elements, array, key)
       implicit none
       integer               length
       integer               handle
       integer               type_code
       integer               N_elements
       integer*8          array(*)
       character(*)          key
     end subroutine Util_TableGetGenericArray

     

     

     subroutine Util_TableSetPointer (info, handle, value, key)
       implicit none
       integer               info
       integer               handle
       integer*8          value
       character(*)          key
     end subroutine Util_TableSetPointer

     subroutine Util_TableSetFPointer (info, handle, value, key)
       implicit none
       integer               info
       integer               handle
       integer*8         value
       character(*)          key
     end subroutine Util_TableSetFPointer

     

     subroutine Util_TableSetByte (info, handle, value, key)
       implicit none
       integer               info
       integer               handle
       INTEGER*1              value
       character(*)          key
     end subroutine Util_TableSetByte

     subroutine Util_TableSetInt (info, handle, value, key)
       implicit none
       integer               info
       integer               handle
       INTEGER*4              value
       character(*)          key
     end subroutine Util_TableSetInt


     subroutine Util_TableSetInt1 (info, handle, value, key)
       implicit none
       integer               info
       integer               handle
       INTEGER*1             value
       character(*)          key
     end subroutine Util_TableSetInt1



     subroutine Util_TableSetInt2 (info, handle, value, key)
       implicit none
       integer               info
       integer               handle
       INTEGER*2             value
       character(*)          key
     end subroutine Util_TableSetInt2



     subroutine Util_TableSetInt4 (info, handle, value, key)
       implicit none
       integer               info
       integer               handle
       INTEGER*4             value
       character(*)          key
     end subroutine Util_TableSetInt4



     subroutine Util_TableSetInt8 (info, handle, value, key)
       implicit none
       integer               info
       integer               handle
       INTEGER*8             value
       character(*)          key
     end subroutine Util_TableSetInt8


     

     subroutine Util_TableSetReal (info, handle, value, key)
       implicit none
       integer               info
       integer               handle
       REAL*8             value
       character(*)          key
     end subroutine Util_TableSetReal


     subroutine Util_TableSetReal4 (info, handle, value, key)
       implicit none
       integer               info
       integer               handle
       REAL*4            value
       character(*)          key
     end subroutine Util_TableSetReal4



     subroutine Util_TableSetReal8 (info, handle, value, key)
       implicit none
       integer               info
       integer               handle
       REAL*8            value
       character(*)          key
     end subroutine Util_TableSetReal8



     subroutine Util_TableSetReal16 (info, handle, value, key)
       implicit none
       integer               info
       integer               handle
       REAL*16           value
       character(*)          key
     end subroutine Util_TableSetReal16


     

     subroutine Util_TableSetComplex (info, handle, value, key)
       implicit none
       integer               info
       integer               handle
       COMPLEX*16          value
       character(*)          key
     end subroutine Util_TableSetComplex


     subroutine Util_TableSetComplex8 (info, handle, value, key)
       implicit none
       integer               info
       integer               handle
       COMPLEX*8         value
       character(*)          key
     end subroutine Util_TableSetComplex8



     subroutine Util_TableSetComplex16 (info, handle, value, key)
       implicit none
       integer               info
       integer               handle
       COMPLEX*16        value
       character(*)          key
     end subroutine Util_TableSetComplex16



     subroutine Util_TableSetComplex32 (info, handle, value, key)
       implicit none
       integer               info
       integer               handle
       COMPLEX*32        value
       character(*)          key
     end subroutine Util_TableSetComplex32


     

     subroutine Util_TableSetPointerArray &
          (info, handle, N_elements, array, key)
       implicit none
       integer               info
       integer               handle
       integer               N_elements
       integer*8          array(*)
       character(*)          key
     end subroutine Util_TableSetPointerArray

     subroutine Util_TableSetFPointerArray &
          (info, handle, N_elements, array, key)
       implicit none
       integer               info
       integer               handle
       integer               N_elements
       integer*8         array(*)
       character(*)          key
     end subroutine Util_TableSetFPointerArray

     

     subroutine Util_TableSetByteArray (info, handle, N_elements, array, key)
       implicit none
       integer               info
       integer               handle
       integer               N_elements
       INTEGER*1              array(*)
       character(*)          key
     end subroutine Util_TableSetByteArray

     subroutine Util_TableSetIntArray (info, handle, N_elements, array, key)
       implicit none
       integer               info
       integer               handle
       integer               N_elements
       INTEGER*4              array(*)
       character(*)          key
     end subroutine Util_TableSetIntArray


     subroutine Util_TableSetInt1Array (info, handle, N_elements, array, key)
       implicit none
       integer               info
       integer               handle
       integer               N_elements
       INTEGER*1             array(*)
       character(*)          key
     end subroutine Util_TableSetInt1Array



     subroutine Util_TableSetInt2Array (info, handle, N_elements, array, key)
       implicit none
       integer               info
       integer               handle
       integer               N_elements
       INTEGER*2             array(*)
       character(*)          key
     end subroutine Util_TableSetInt2Array



     subroutine Util_TableSetInt4Array (info, handle, N_elements, array, key)
       implicit none
       integer               info
       integer               handle
       integer               N_elements
       INTEGER*4             array(*)
       character(*)          key
     end subroutine Util_TableSetInt4Array



     subroutine Util_TableSetInt8Array (info, handle, N_elements, array, key)
       implicit none
       integer               info
       integer               handle
       integer               N_elements
       INTEGER*8             array(*)
       character(*)          key
     end subroutine Util_TableSetInt8Array


     

     subroutine Util_TableSetRealArray (info, handle, N_elements, array, key)
       implicit none
       integer               info
       integer               handle
       integer               N_elements
       REAL*8             array(*)
       character(*)          key
     end subroutine Util_TableSetRealArray


     subroutine Util_TableSetReal4Array (info, handle, N_elements, array, key)
       implicit none
       integer               info
       integer               handle
       integer               N_elements
       REAL*4            array(*)
       character(*)          key
     end subroutine Util_TableSetReal4Array



     subroutine Util_TableSetReal8Array (info, handle, N_elements, array, key)
       implicit none
       integer               info
       integer               handle
       integer               N_elements
       REAL*8            array(*)
       character(*)          key
     end subroutine Util_TableSetReal8Array



     subroutine Util_TableSetReal16Array (info, handle, N_elements, array, key)
       implicit none
       integer               info
       integer               handle
       integer               N_elements
       REAL*16           array(*)
       character(*)          key
     end subroutine Util_TableSetReal16Array


     

     subroutine Util_TableSetComplexArray &
          (info, handle, N_elements, array, key)
       implicit none
       integer               info
       integer               handle
       integer               N_elements
       COMPLEX*16          array(*)
       character(*)          key
     end subroutine Util_TableSetComplexArray


     subroutine Util_TableSetComplex8Array &
          (info, handle, N_elements, array, key)
       implicit none
       integer               info
       integer               handle
       integer               N_elements
       COMPLEX*8         array(*)
       character(*)          key
     end subroutine Util_TableSetComplex8Array



     subroutine Util_TableSetComplex16Array &
          (info, handle, N_elements, array, key)
       implicit none
       integer               info
       integer               handle
       integer               N_elements
       COMPLEX*16         array(*)
       character(*)          key
     end subroutine Util_TableSetComplex16Array



     subroutine Util_TableSetComplex32Array &
          (info, handle, N_elements, array, key)
       implicit none
       integer               info
       integer               handle
       integer               N_elements
       COMPLEX*32         array(*)
       character(*)          key
     end subroutine Util_TableSetComplex32Array


     

     

     subroutine Util_TableGetPointer (length, handle, value, key)
       implicit none
       integer               length
       integer               handle
       integer*8          value
       character(*)          key
     end subroutine Util_TableGetPointer

     subroutine Util_TableGetFPointer (length, handle, value, key)
       implicit none
       integer               length
       integer               handle
       integer*8         value
       character(*)          key
     end subroutine Util_TableGetFPointer

     

     subroutine Util_TableGetByte (length, handle, value, key)
       implicit none
       integer               length
       integer               handle
       INTEGER*1              value
       character(*)          key
     end subroutine Util_TableGetByte

     subroutine Util_TableGetInt (length, handle, value, key)
       implicit none
       integer               length
       integer               handle
       INTEGER*4              value
       character(*)          key
     end subroutine Util_TableGetInt


     subroutine Util_TableGetInt1 (length, handle, value, key)
       implicit none
       integer               length
       integer               handle
       INTEGER*1             value
       character(*)          key
     end subroutine Util_TableGetInt1



     subroutine Util_TableGetInt2 (length, handle, value, key)
       implicit none
       integer               length
       integer               handle
       INTEGER*2             value
       character(*)          key
     end subroutine Util_TableGetInt2



     subroutine Util_TableGetInt4 (length, handle, value, key)
       implicit none
       integer               length
       integer               handle
       INTEGER*4             value
       character(*)          key
     end subroutine Util_TableGetInt4



     subroutine Util_TableGetInt8 (length, handle, value, key)
       implicit none
       integer               length
       integer               handle
       INTEGER*8             value
       character(*)          key
     end subroutine Util_TableGetInt8


     

     subroutine Util_TableGetReal (length, handle, value, key)
       implicit none
       integer               length
       integer               handle
       REAL*8             value
       character(*)          key
     end subroutine Util_TableGetReal


     subroutine Util_TableGetReal4 (length, handle, value, key)
       implicit none
       integer               length
       integer               handle
       REAL*4            value
       character(*)          key
     end subroutine Util_TableGetReal4



     subroutine Util_TableGetReal8 (length, handle, value, key)
       implicit none
       integer               length
       integer               handle
       REAL*8            value
       character(*)          key
     end subroutine Util_TableGetReal8



     subroutine Util_TableGetReal16 (length, handle, value, key)
       implicit none
       integer               length
       integer               handle
       REAL*16           value
       character(*)          key
     end subroutine Util_TableGetReal16


     

     subroutine Util_TableGetComplex (length, handle, value, key)
       implicit none
       integer               length
       integer               handle
       COMPLEX*16          value
       character(*)          key
     end subroutine Util_TableGetComplex


     subroutine Util_TableGetComplex8 (length, handle, value, key)
       implicit none
       integer               length
       integer               handle
       COMPLEX*8         value
       character(*)          key
     end subroutine Util_TableGetComplex8



     subroutine Util_TableGetComplex16 (length, handle, value, key)
       implicit none
       integer               length
       integer               handle
       COMPLEX*16        value
       character(*)          key
     end subroutine Util_TableGetComplex16



     subroutine Util_TableGetComplex32 (length, handle, value, key)
       implicit none
       integer               length
       integer               handle
       COMPLEX*32        value
       character(*)          key
     end subroutine Util_TableGetComplex32


     

     subroutine Util_TableGetPointerArray &
          (length, handle, N_elements, array, key)
       implicit none
       integer               length
       integer               handle
       integer               N_elements
       integer*8          array(*)
       character(*)          key
     end subroutine Util_TableGetPointerArray

     subroutine Util_TableGetFPointerArray &
          (length, handle, N_elements, array, key)
       implicit none
       integer               length
       integer               handle
       integer               N_elements
       integer*8         array(*)
       character(*)          key
     end subroutine Util_TableGetFPointerArray

     

     subroutine Util_TableGetByteArray (length, handle, N_elements, array, key)
       implicit none
       integer               length
       integer               handle
       integer               N_elements
       INTEGER*1              array(*)
       character(*)          key
     end subroutine Util_TableGetByteArray

     subroutine Util_TableGetIntArray (length, handle, N_elements, array, key)
       implicit none
       integer               length
       integer               handle
       integer               N_elements
       INTEGER*4              array(*)
       character(*)          key
     end subroutine Util_TableGetIntArray


     subroutine Util_TableGetInt1Array (length, handle, N_elements, array, key)
       implicit none
       integer               length
       integer               handle
       integer               N_elements
       INTEGER*1             array(*)
       character(*)          key
     end subroutine Util_TableGetInt1Array



     subroutine Util_TableGetInt2Array (length, handle, N_elements, array, key)
       implicit none
       integer               length
       integer               handle
       integer               N_elements
       INTEGER*2             array(*)
       character(*)          key
     end subroutine Util_TableGetInt2Array



     subroutine Util_TableGetInt4Array (length, handle, N_elements, array, key)
       implicit none
       integer               length
       integer               handle
       integer               N_elements
       INTEGER*4             array(*)
       character(*)          key
     end subroutine Util_TableGetInt4Array



     subroutine Util_TableGetInt8Array (length, handle, N_elements, array, key)
       implicit none
       integer               length
       integer               handle
       integer               N_elements
       INTEGER*8             array(*)
       character(*)          key
     end subroutine Util_TableGetInt8Array


     

     subroutine Util_TableGetRealArray (length, handle, N_elements, array, key)
       implicit none
       integer               length
       integer               handle
       integer               N_elements
       REAL*8             array(*)
       character(*)          key
     end subroutine Util_TableGetRealArray


     subroutine Util_TableGetReal4Array &
          (length, handle, N_elements, array, key)
       implicit none
       integer               length
       integer               handle
       integer               N_elements
       REAL*4            array(*)
       character(*)          key
     end subroutine Util_TableGetReal4Array



     subroutine Util_TableGetReal8Array &
          (length, handle, N_elements, array, key)
       implicit none
       integer               length
       integer               handle
       integer               N_elements
       REAL*8            array(*)
       character(*)          key
     end subroutine Util_TableGetReal8Array



     subroutine Util_TableGetReal16Array &
          (length, handle, N_elements, array, key)
       implicit none
       integer               length
       integer               handle
       integer               N_elements
       REAL*16           array(*)
       character(*)          key
     end subroutine Util_TableGetReal16Array


     

     subroutine Util_TableGetComplexArray &
          (length, handle, N_elements, array, key)
       implicit none
       integer               length
       integer               handle
       integer               N_elements
       COMPLEX*16          array(*)
       character(*)          key
     end subroutine Util_TableGetComplexArray


     subroutine Util_TableGetComplex8Array &
          (length, handle, N_elements, array, key)
       implicit none
       integer               length
       integer               handle
       integer               N_elements
       COMPLEX*8         array(*)
       character(*)          key
     end subroutine Util_TableGetComplex8Array



     subroutine Util_TableGetComplex16Array &
          (length, handle, N_elements, array, key)
       implicit none
       integer               length
       integer               handle
       integer               N_elements
       COMPLEX*16        array(*)
       character(*)          key
     end subroutine Util_TableGetComplex16Array



     subroutine Util_TableGetComplex32Array &
          (length, handle, N_elements, array, key)
       implicit none
       integer               length
       integer               handle
       integer               N_elements
       COMPLEX*32        array(*)
       character(*)          key
     end subroutine Util_TableGetComplex32Array


     

     

     subroutine Util_TableItCreate (ihandle, handle)
       implicit none
       integer               ihandle
       integer               handle
     end subroutine Util_TableItCreate

     subroutine Util_TableItClone (newihandle, ihandle)
       implicit none
       integer               newihandle
       integer               ihandle
     end subroutine Util_TableItClone

     subroutine Util_TableItDestroy (ierr, ihandle)
       implicit none
       integer               ierr
       integer               ihandle
     end subroutine Util_TableItDestroy

     

     subroutine Util_TableItQueryIsNull (info, ihandle)
       implicit none
       integer               info
       integer               ihandle
     end subroutine Util_TableItQueryIsNull

     subroutine Util_TableItQueryIsNonNull (info, ihandle)
       implicit none
       integer               info
       integer               ihandle
     end subroutine Util_TableItQueryIsNonNull

     

     subroutine Util_TableItQueryTableHandle (handle, ihandle)
       implicit none
       integer               handle
       integer               ihandle
     end subroutine Util_TableItQueryTableHandle

     subroutine Util_TableItQueryKeyValueInfo &
          (length, ihandle, key_buffer, type_code, N_elements)
       implicit none
       integer               length
       integer               ihandle
       character(*)          key_buffer
       INTEGER*4              type_code
       INTEGER*4              N_elements
     end subroutine Util_TableItQueryKeyValueInfo

     

     subroutine Util_TableItAdvance (info, ihandle)
       implicit none
       integer               info
       integer               ihandle
     end subroutine Util_TableItAdvance

     subroutine Util_TableItResetToStart (info, ihandle)
       implicit none
       integer               info
       integer               ihandle
     end subroutine Util_TableItResetToStart

     subroutine Util_TableItSetToNull (ierr, ihandle)
       implicit none
       integer               ierr
       integer               ihandle
     end subroutine Util_TableItSetToNull

     subroutine Util_TableItSetToKey (ierr, ihandle, key)
       implicit none
       integer               ierr
       integer               ihandle
       character(*)          key
     end subroutine Util_TableItSetToKey

  end interface

end module util_Table
